## camp 0.7.1.1

=== CMakeLists.txt ===
###############################################################################
##
## Copyright (C) 2009-2010 TECHNOGERMA Systems France and/or its subsidiary(-ies).
## Contact: Technogerma Systems France Information (contact@technogerma.fr)
##
## This file is part of the CAMP library.
##
## CAMP is free software: you can redistribute it and/or modify
## it under the terms of the GNU Lesser General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
## 
## CAMP is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU Lesser General Public License for more details.
## 
## You should have received a copy of the GNU Lesser General Public License
## along with CAMP.  If not, see <http://www.gnu.org/licenses/>.
##
###############################################################################


cmake_minimum_required(VERSION 2.6)

# set project's name
project(CAMP)

# include project configuration
include(${CMAKE_SOURCE_DIR}/cmake/Config.cmake)
include(${CMAKE_SOURCE_DIR}/cmake/PackageFilename.cmake)

# all source files
set(CAMP_SRCS
    include/camp/userproperty.hpp
    src/userproperty.cpp
    include/camp/userobject.hpp
    include/camp/userobject.inl
    src/userobject.cpp
    include/camp/tagholder.hpp
    src/tagholder.cpp
    include/camp/simpleproperty.hpp
    src/simpleproperty.cpp
    include/camp/property.hpp
    src/property.cpp
    include/camp/observer.hpp
    src/observer.cpp
    include/camp/errors.hpp
    src/errors.cpp
    include/camp/function.hpp
    src/function.cpp
    include/camp/error.hpp
    src/error.cpp
    include/camp/enumproperty.hpp
    src/enumproperty.cpp
    include/camp/enumobject.hpp
    include/camp/enumobject.inl
    src/enumobject.cpp
    include/camp/enumbuilder.hpp
    src/enumbuilder.cpp
    include/camp/enum.hpp
    include/camp/enum.inl
    src/enum.cpp
    include/camp/classvisitor.hpp
    src/classvisitor.cpp
    include/camp/class.hpp
    include/camp/class.inl
    src/class.cpp
    include/camp/arrayproperty.hpp
    src/arrayproperty.cpp
    include/camp/args.hpp
    src/args.cpp
    include/camp/value.hpp
    include/camp/value.inl
    src/value.cpp
    include/camp/detail/classmanager.hpp
    src/classmanager.cpp
    include/camp/detail/enummanager.hpp
    src/enummanager.cpp
    include/camp/detail/observernotifier.hpp
    src/observernotifier.cpp
    include/camp/camptype.hpp
    src/camptype.cpp
    include/camp/classcast.hpp
    src/classcast.cpp
    include/camp/type.hpp
    include/camp/enumget.hpp
    include/camp/enumget.inl
    include/camp/constructor.hpp
    include/camp/config.hpp
    include/camp/classget.hpp
    include/camp/classget.inl
    include/camp/classbuilder.hpp
    include/camp/classbuilder.inl
    include/camp/arraymapper.hpp
    include/camp/valuemapper.hpp
    include/camp/valuevisitor.hpp
    include/camp/detail/valueimpl.hpp
    include/camp/detail/userpropertyimpl.hpp
    include/camp/detail/userpropertyimpl.inl
    include/camp/detail/typeid.hpp
    include/camp/detail/simplepropertyimpl.hpp
    include/camp/detail/simplepropertyimpl.inl
    include/camp/detail/returntype.hpp
    include/camp/detail/rawtype.hpp
    include/camp/detail/propertyfactory.hpp
    include/camp/detail/objecttraits.hpp
    include/camp/detail/issmartpointer.hpp
    include/camp/detail/getter.hpp
    include/camp/detail/getter.inl
    include/camp/detail/functiontraits.hpp
    include/camp/detail/functionimpl.hpp
    include/camp/detail/enumpropertyimpl.hpp
    include/camp/detail/enumpropertyimpl.inl
    include/camp/detail/constructorimpl.hpp
    include/camp/detail/callhelper.hpp
    include/camp/detail/arraypropertyimpl.hpp
    include/camp/detail/arraypropertyimpl.inl
    include/camp/detail/yesnotype.hpp
    include/camp/detail/objectholder.hpp
    include/camp/detail/objectholder.inl
    include/camp/detail/valueprovider.hpp
    include/camp/qt/qthelper.hpp
    include/camp/qt/qtsimpleproperty.hpp
    include/camp/qt/qtmapper.hpp
    include/camp/qt/qt.hpp
    include/camp/qt/qstring.hpp
    include/camp/qt/qlist.hpp
    include/camp/qt/qvector.hpp
    include/camp/qt/qtfunction.hpp
)

# find Boost
find_package(Boost 1.38.0 REQUIRED)

# include files search paths
include_directories(
    ${CAMP_SOURCE_DIR}/include
    ${Boost_INCLUDE_DIRS}
)

# generate version.hpp
message("Generate version.hpp")
configure_file(${CMAKE_SOURCE_DIR}/version.in ${CMAKE_BINARY_DIR}/version.hpp @ONLY)

# instruct CMake to build a shared library from all of the source files
add_library(camp ${CAMP_SRCS})

# define the export macro
if(BUILD_SHARED_LIBS)
    set_target_properties(camp PROPERTIES DEFINE_SYMBOL CAMP_EXPORTS)
else()
    add_definitions(-DCAMP_STATIC)
endif()

# define d suffix on windows
if(WIN32)
    set_target_properties(camp PROPERTIES DEBUG_POSTFIX d)
endif()

# gcc 4.x on Windows requires the -static-libgcc linker option to get rid of an extra DLL
if (WIN32 AND CMAKE_COMPILER_IS_GNUCXX)
    if(${GCC_VERSION} MATCHES "4\\..*")
        set_target_properties(camp PROPERTIES LINK_FLAGS -static-libgcc)
    endif()
endif()

# add the test subdirectory, but do not build it by default
if(BUILD_TEST)
    add_subdirectory(test)
endif()

###############################
# doc
###############################

add_subdirectory(doc)

###############################
# installing
###############################

install(DIRECTORY include
    DESTINATION .
    COMPONENT devel
)

install(FILES ${CMAKE_BINARY_DIR}/version.hpp
    DESTINATION include/camp
    COMPONENT devel
)

install(TARGETS camp
    RUNTIME DESTINATION bin COMPONENT bin
    LIBRARY DESTINATION lib COMPONENT bin 
    ARCHIVE DESTINATION lib COMPONENT devel
)

install(FILES README.txt COPYING.txt LICENSE.LGPL3.txt
    DESTINATION ${INSTALL_MISC_DIR}
)

install(DIRECTORY cmake
    DESTINATION ${INSTALL_MISC_DIR}
    COMPONENT utils
)

###############################
# packaging
###############################

include(${CAMP_SOURCE_DIR}/cmake/Packaging.cmake OPTIONAL)

=== doc/CMakeLists.txt ===
###############################################################################
##
## Copyright (C) 2009-2010 TECHNOGERMA Systems France and/or its subsidiary(-ies).
## Contact: Technogerma Systems France Information (contact@technogerma.fr)
##
## This file is part of the CAMP library.
##
## CAMP is free software: you can redistribute it and/or modify
## it under the terms of the GNU Lesser General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
## 
## CAMP is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU Lesser General Public License for more details.
## 
## You should have received a copy of the GNU Lesser General Public License
## along with CAMP.  If not, see <http://www.gnu.org/licenses/>.
##
###############################################################################


###############################
# doc
###############################

find_package(Doxygen)
if(DOXYGEN_FOUND)
    # setup variables to be replaced in the source Doxyfile
    set(DOXYGEN_INPUT_DIR ${CMAKE_SOURCE_DIR})
   
    ###################################
    # local documentation
    ###################################

    set(DOXYGEN_OUTPUT_TYPE html)
    set(DOXYGEN_CONFIGURED_INPUT ${CMAKE_BINARY_DIR}/doc/campapi.doxy)
    set(DOXYGEN_OUTPUT_DIR ${CMAKE_BINARY_DIR}/doc/api)

    if(WIN32)
        set(DOXYGEN_GENERATE_MAN NO)
        find_program(HHC_PROGRAM 
            NAMES hhc.exe 
            PATHS "c:/Program Files/HTML Help Workshop"
            DOC "HTML Help Compiler program")
        if(HHC_PROGRAM)
            set(DOXYGEN_GENERATE_HTMLHELP YES)
        else()
            set(DOXYGEN_GENERATE_HTMLHELP NO)
        endif()
    else()
        set(DOXYGEN_GENERATE_MAN NO)
        set(DOXYGEN_GENERATE_HTMLHELP NO)
        set(HHC_PROGRAM)
    endif()

    # configure the source Doxyfile by copying it and replacing all @variables@
    configure_file(${DOXYGEN_INPUT_DIR}/doc/api/Doxyfile.in ${DOXYGEN_CONFIGURED_INPUT} @ONLY)

    # copy necessary doc files
    file(GLOB image_files ${DOXYGEN_INPUT_DIR}/doc/api/images/*)
    foreach(file ${image_files})
        get_filename_component(filename ${file} NAME)
        configure_file(${file} ${DOXYGEN_OUTPUT_DIR}/${DOXYGEN_OUTPUT_TYPE}/${filename} COPYONLY)
    endforeach()

    # target setup
    add_custom_target(doc
        COMMAND ${CMAKE_COMMAND} -E echo_append "Building API Documentation..."
        COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYGEN_CONFIGURED_INPUT}
        COMMAND ${CMAKE_COMMAND} -E echo "Done."
        WORKING_DIRECTORY ${DOXYGEN_INPUT_DIR}
    )

    # install
    install(DIRECTORY ${DOXYGEN_OUTPUT_DIR}
        DESTINATION ${INSTALL_MISC_DIR}/doc
        COMPONENT apidoc
    )
endif()

=== test/CMakeLists.txt ===
###############################################################################
##
## Copyright (C) 2009-2010 TECHNOGERMA Systems France and/or its subsidiary(-ies).
## Contact: Technogerma Systems France Information (contact@technogerma.fr)
##
## This file is part of the CAMP library.
##
## CAMP is free software: you can redistribute it and/or modify
## it under the terms of the GNU Lesser General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
## 
## CAMP is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU Lesser General Public License for more details.
## 
## You should have received a copy of the GNU Lesser General Public License
## along with CAMP.  If not, see <http://www.gnu.org/licenses/>.
##
###############################################################################


cmake_minimum_required(VERSION 2.6)

# set project's name
project(CAMP_TEST)

# all source files
set(CAMP_TEST_SRCS
    main.cpp
    arrayproperty.cpp
    arrayproperty.hpp
    class.cpp
    class.hpp
    enum.cpp
    enum.hpp
    enumobject.cpp
    enumobject.hpp
    enumproperty.cpp
    enumproperty.hpp
    tagholder.cpp
    tagholder.hpp
    value.cpp
    value.hpp
    property.cpp
    property.hpp
    classvisitor.cpp
    classvisitor.hpp
    constructor.cpp
    constructor.hpp
    mapper.cpp
    mapper.hpp
    inheritance.cpp
    inheritance.hpp
    userobject.cpp
    userobject.hpp
    propertyaccess.cpp
    propertyaccess.hpp
    functionaccess.cpp
    functionaccess.hpp
)

# find Boost
find_package(Boost 1.38.0)

# include files search paths
include_directories(
    ${CAMP_SOURCE_DIR}/include
    ${Boost_INCLUDE_DIRS}
)

# linker search paths
link_directories(
    ${CAMP_BINARY_DIR}
)

# no implicit link to boost.test library
add_definitions(-DBOOST_TEST_NO_LIB)

# instruct CMake to build an executable from all of the source files
add_executable(camptest ${CAMP_TEST_SRCS})

# define d suffix on windows
if(WIN32)
    set_target_properties(camptest PROPERTIES DEBUG_POSTFIX d)
endif()

# last thing we have to do is to tell CMake what libraries our executable needs,
target_link_libraries(camptest camp)

# add the qt subdirectory, but do not build it by default
if(BUILD_TEST_QT)
    add_subdirectory(qt)
endif()

=== test/qt/CMakeLists.txt ===
###############################################################################
##
## Copyright (C) 2009-2010 TECHNOGERMA Systems France and/or its subsidiary(-ies).
## Contact: Technogerma Systems France Information (contact@technogerma.fr)
##
## This file is part of the CAMP library.
##
## CAMP is free software: you can redistribute it and/or modify
## it under the terms of the GNU Lesser General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
## 
## CAMP is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU Lesser General Public License for more details.
## 
## You should have received a copy of the GNU Lesser General Public License
## along with CAMP.  If not, see <http://www.gnu.org/licenses/>.
##
###############################################################################


cmake_minimum_required(VERSION 2.6)

# set project's name
project(CAMP_TEST_QT)

# all source files
set(CAMP_TEST_QT_SRCS
    main.cpp
    functionmapping.cpp
    functionmapping.hpp
    propertymapping.cpp
    propertymapping.hpp
    qstringmapping.cpp
)

# find Boost
find_package(Boost 1.38.0)

# find Qt4
find_package(Qt4 4.5.0 COMPONENTS QtCore REQUIRED)

# add some useful macros and variables
# (QT_USE_FILE is a variable defined by find_package( Qt4 ) that contains a path to CMake script)
include(${QT_USE_FILE})

# this will run moc
QT4_WRAP_CPP(CAMP_TEST_QT_MOC_SRCS functionmapping.hpp propertymapping.hpp)

# include files search paths
include_directories(
    ${CAMP_SOURCE_DIR}/include
    ${Boost_INCLUDE_DIRS}
)

# linker search paths
link_directories(
    ${CAMP_BINARY_DIR}
)

# no implicit link to boost.test library
add_definitions(-DBOOST_TEST_NO_LIB)

# instruct CMake to build an executable from all of the source files
add_executable(camptest-qt ${CAMP_TEST_QT_SRCS} ${CAMP_TEST_QT_MOC_SRCS})

# last thing we have to do is to tell CMake what libraries our executable needs
target_link_libraries(camptest-qt camp ${QT_LIBRARIES})

=== debian/changelog ===
camp (0.7.1.1-1) unstable; urgency=low

  * Initial release (Closes: #759244)

 -- Corentin Desfarges <corentin.desfarges.dev@gmail.com>  Wed, 10 Sep 2014 09:45:00 +0200

=== debian/control ===
Source: camp
Maintainer: Corentin Desfarges <corentin.desfarges.dev@gmail.com>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper (>= 9),
               libboost-dev,
               libboost-test-dev,
               libqt4-dev
Standards-Version: 3.9.5
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/camp.git
Vcs-Git: git://anonscm.debian.org/debian-med/camp.git
Homepage: https://github.com/tegesoft/camp

Package: libcamp0.7
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: C++ multi-purpose reflection library
 CAMP is a multi-purpose reflection library developed by Technogerma Systems
 France (http://www.tegesoft.com).
 It provides an abstraction for most of the high-level concepts of C++
  - Classes
  - Enumerations
  - Properties
  - Functions
  - Objects
  - Variables
 By wrapping all these concepts into abstract structures, CAMP provides an
 extra layer of flexibility to programs, and allow them to fully expose their
 data structures at runtime.
 Many applications can take advantage of CAMP, in order to automate tasks which
 would otherwise require a huge amount of work. For example, CAMP can be used
 to expose and edit objects' attributes into a graphical user interface. It can
 also be used to do automatic binding of C++ classes to script languages such as
 Python or Lua.
 Another possible application would be the serialization of objects to XML, text
 or binary formats. Or you can even combine all these examples to provide a
 powerful and consistent interface for manipulating your objects outside C++
 code.

Package: libcamp0.7-dev
Architecture: any
Section: libdevel
Depends: libcamp0.7 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Provides: libcamp-dev
Description: C++ multi-purpose reflection library (development files)
 CAMP is a multi-purpose reflection library developed by Technogerma Systems
 France (http://www.tegesoft.com).
 It provides an abstraction for most of the high-level concepts of C++
  - Classes
  - Enumerations
  - Properties
  - Functions
  - Objects
  - Variables
 By wrapping all these concepts into abstract structures, CAMP provides an
 extra layer of flexibility to programs, and allow them to fully expose their
 data structures at runtime.
 Many applications can take advantage of CAMP, in order to automate tasks which
 would otherwise require a huge amount of work. For example, CAMP can be used
 to expose and edit objects' attributes into a graphical user interface. It can
 also be used to do automatic binding of C++ classes to script languages such as
 Python or Lua.
 Another possible application would be the serialization of objects to XML, text
 or binary formats. Or you can even combine all these examples to provide a
 powerful and consistent interface for manipulating your objects outside C++
 code.
 .
 This package contains the development files needed to build you own VXL apps.

=== debian/watch ===
version=3
https://github.com/greenjava/camp/releases .*/archive/(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## camp 0.7.1.3

=== debian/changelog ===
camp (0.7.1.3-1) unstable; urgency=medium

  * New upstream version
  * Fix end of line issues
  * Support of c++11

 -- Corentin Desfarges <corentin.desfarges.dev@gmail.com>  Tue, 12 Jan 2016 12:11:51 +0100

camp (0.7.1.1-2) unstable; urgency=medium

  * Apply patch to prevent parse error at "BOOST_JOIN". Closes: #795497.
  * Team maintenance in Debian Med team

 -- Corentin Desfarges <corentin.desfarges.dev@gmail.com>  Mon, 21 Dec 2015 12:59:59 +0200

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: camp
-Maintainer: Corentin Desfarges <corentin.desfarges.dev@gmail.com>
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Uploaders: Corentin Desfarges <corentin.desfarges.dev@gmail.com>
 Section: science
 Priority: optional
 Build-Depends: cmake,
@@ -7,7 +8,7 @@
                libboost-dev,
                libboost-test-dev,
                libqt4-dev
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/camp.git
 Vcs-Git: git://anonscm.debian.org/debian-med/camp.git
 Homepage: https://github.com/tegesoft/camp

=== debian/rules ===
#!/usr/bin/make -f

CPPFLAGS:=-std=c++11

%:
	dh $@

=== debian/watch ===
version=3
https://github.com/corentindesfarges/camp/releases .*/archive/(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## camp 0.8.1

=== test/qt/CMakeLists.txt ===
###############################################################################
##
## Copyright (C) 2009-2014 TEGESO/TEGESOFT and/or its subsidiary(-ies) and mother company.
## Contact: Tegesoft Information (contact@tegesoft.com)
##
## This file is part of the CAMP library.
##
## The MIT License (MIT)
##
## Copyright (c) 2009-2014 TEGESO/TEGESOFT
##
## Permission is hereby granted, free of charge, to any person obtaining a copy
## of this software and associated documentation files (the "Software"), to deal
## in the Software without restriction, including without limitation the rights
## to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
## copies of the Software, and to permit persons to whom the Software is
## furnished to do so, subject to the following conditions:
##
## The above copyright notice and this permission notice shall be included in
## all copies or substantial portions of the Software.
##
## THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
## IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
## FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
## AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
## LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
## OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
## THE SOFTWARE.
##
###############################################################################


cmake_minimum_required(VERSION 2.6)

# set project's name
project(CAMP_TEST_QT)

# all source files
set(CAMP_TEST_QT_SRCS
    main.cpp
    functionmapping.cpp
    functionmapping.hpp
    propertymapping.cpp
    propertymapping.hpp
    qstringmapping.cpp
)

# find Boost
find_package(Boost 1.38.0)

# find Qt4
find_package(Qt5 COMPONENTS Core REQUIRED)

# include files search paths
include_directories(
    ${CAMP_SOURCE_DIR}/include
    ${Qt5Core_INCLUDE_DIRS}
    ${Boost_INCLUDE_DIRS}
)

# no implicit link to boost.test library
add_definitions(-DBOOST_TEST_NO_LIB)

# instruct CMake to build an executable from all of the source files
add_executable(camptest-qt ${CAMP_TEST_QT_SRCS} ${CAMP_TEST_QT_MOC_SRCS})

set_target_properties(camptest-qt PROPERTIES AUTOMOC TRUE)

# last thing we have to do is to tell CMake what libraries our executable needs
target_link_libraries(camptest-qt camp ${Qt5Core_LIBRARIES})

# Add the CTest
add_test(camptest-qt camptest-qt)

=== debian/changelog ===
camp (0.8.1-2) unstable; urgency=medium

  * d/control: Add proper conflicts/replaces with 0.7 versions. Closes: #876130

 -- Flavien Bridault <fbridault@ircad.fr>  Tue, 19 Sep 2017 07:35:20 +0000

camp (0.8.1-1) unstable; urgency=medium

  * d/control: Remove unrelated last line. Closes: #813714.
  * d/control: Move to standards version 4.0.1 
  * d/copyright: Change licence to MIT according to upstream change
  * d/patches: Remove patches integrated upstream
  * New upstream version 0.8.1 that drops Qt4 in favor of Qt5. Closes: #874842 

 -- Flavien Bridault <fbridault@ircad.fr>  Thu, 14 Sep 2017 10:41:47 +0000

camp (0.7.1.5-1) unstable; urgency=medium

  [ Flavien Bridault ]
  * New upstream version
  * Removed Corentin Desfarges as Uploader
  * Added myself as Uploader
  * d/watch: Moved to official fw4spl fork
  * d/rules: Enabled parallel build
  * d/support_c++11.patch: Removed, was integrated upstream.
  * cme fix dpkg-control
  * d/control: Multi-arch
  * d/copyright: Fixed licences
  * d/patches/remove_licences_files.patch: Only prevent licence install,
    do not delete.

  [ Andreas Tille ]
  * debhelper 10 (which enables parallel build as default)
  * hardening=+all
  * drop version number from -dev package

 -- Flavien Bridault <fbridault@ircad.fr>  Thu, 24 Nov 2016 11:16:24 +0100

=== debian/control ===
--- 
+++ 
@@ -1,23 +1,28 @@
 Source: camp
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Corentin Desfarges <corentin.desfarges.dev@gmail.com>
+Uploaders: Flavien Bridault <fbridault@ircad.fr>
 Section: science
 Priority: optional
 Build-Depends: cmake,
-               debhelper (>= 9),
+               debhelper (>= 10),
+               d-shlibs,
                libboost-dev,
                libboost-test-dev,
-               libqt4-dev
-Standards-Version: 3.9.6
+               qtbase5-dev
+Standards-Version: 4.1.0
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/camp.git
-Vcs-Git: git://anonscm.debian.org/debian-med/camp.git
+Vcs-Git: https://anonscm.debian.org/git/debian-med/camp.git
 Homepage: https://github.com/tegesoft/camp
 
-Package: libcamp0.7
+Package: libcamp0.8
 Architecture: any
+Multi-Arch: same
 Section: libs
-Depends: ${misc:Depends},
-         ${shlibs:Depends}
+Depends: ${shlibs:Depends},
+         ${misc:Depends}
+Replaces: libcamp0.7
+Provides: libcamp0.7
+Conflicts: libcamp0.7
 Description: C++ multi-purpose reflection library
  CAMP is a multi-purpose reflection library developed by Technogerma Systems
  France (http://www.tegesoft.com).
@@ -41,13 +46,16 @@
  powerful and consistent interface for manipulating your objects outside C++
  code.
 
-Package: libcamp0.7-dev
+Package: libcamp-dev
 Architecture: any
+Multi-Arch: same
 Section: libdevel
-Depends: libcamp0.7 (= ${binary:Version}),
+Depends: libcamp0.8 (= ${binary:Version}),
          ${shlibs:Depends},
          ${misc:Depends}
-Provides: libcamp-dev
+Conflicts: libcamp0.7-dev
+Provides: libcamp0.7-dev
+Replaces: libcamp0.7-dev
 Description: C++ multi-purpose reflection library (development files)
  CAMP is a multi-purpose reflection library developed by Technogerma Systems
  France (http://www.tegesoft.com).
@@ -71,4 +79,4 @@
  powerful and consistent interface for manipulating your objects outside C++
  code.
  .
- This package contains the development files needed to build you own VXL apps.
+ This package contains the files needed for development.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_TEST=TRUE -DBUILD_TEST_QT=TRUE

override_dh_install:
	dh_install
	d-shlibmove \
		--commit --multiarch --devunversioned --exclude-a --exclude-la \
		--movedev debian/tmp/usr/include/camp usr/include \
		--movedev debian/tmp/usr/include/camp-xml usr/include \
		debian/tmp/usr/lib/*.so

=== debian/watch ===
version=3
https://github.com/fw4spl-org/camp/releases .*/archive/(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## camp 0.8.2

=== debian/changelog ===
camp (0.8.2-2) unstable; urgency=medium

  * d/rules: Install CMake files
  * d/p/fix_cmake_target.patch: Use arch dependent library dir
  * Use `cme fix dpkg-control` to
     - Update Standards-Version: 4.4.0

 -- Flavien Bridault <fbridault@ircad.fr>  Sat, 20 Jul 2019 10:23:10 +0000

camp (0.8.2-1) unstable; urgency=medium

  [ Flavien Bridault ]
  * New upstream version 0.8.2. Closes: #876147 
  * d/patches: Remove obsolete hide_boost_from_qt4moc.patch

  [ Andreas Tille ]
  * Use `cme fix dpkg-control` to
     - Update Standards-Version: 4.1.4
     - Point Vcs fields to salsa.debian.org
  * debhelper 11

 -- Flavien Bridault <fbridault@ircad.fr>  Mon, 16 Apr 2018 16:33:23 +0200

=== debian/control ===
--- 
+++ 
@@ -4,14 +4,14 @@
 Section: science
 Priority: optional
 Build-Depends: cmake,
-               debhelper (>= 10),
+               debhelper (>= 11~),
                d-shlibs,
                libboost-dev,
                libboost-test-dev,
                qtbase5-dev
-Standards-Version: 4.1.0
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/camp.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/camp.git
+Standards-Version: 4.4.0
+Vcs-Browser: https://salsa.debian.org/med-team/camp
+Vcs-Git: https://salsa.debian.org/med-team/camp.git
 Homepage: https://github.com/tegesoft/camp
 
 Package: libcamp0.8
@@ -20,9 +20,9 @@
 Section: libs
 Depends: ${shlibs:Depends},
          ${misc:Depends}
+Conflicts: libcamp0.7
+Provides: libcamp0.7
 Replaces: libcamp0.7
-Provides: libcamp0.7
-Conflicts: libcamp0.7
 Description: C++ multi-purpose reflection library
  CAMP is a multi-purpose reflection library developed by Technogerma Systems
  France (http://www.tegesoft.com).

## camp 0.8.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,30 +1,43 @@
 ###############################################################################
 ##
-## Copyright (C) 2009-2010 TECHNOGERMA Systems France and/or its subsidiary(-ies).
-## Contact: Technogerma Systems France Information (contact@technogerma.fr)
+## Copyright (C) 2009-2014 TEGESO/TEGESOFT and/or its subsidiary(-ies) and mother company.
+## Contact: Tegesoft Information (contact@tegesoft.com)
 ##
 ## This file is part of the CAMP library.
 ##
-## CAMP is free software: you can redistribute it and/or modify
-## it under the terms of the GNU Lesser General Public License as published by
-## the Free Software Foundation, either version 3 of the License, or
-## (at your option) any later version.
-## 
-## CAMP is distributed in the hope that it will be useful,
-## but WITHOUT ANY WARRANTY; without even the implied warranty of
-## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-## GNU Lesser General Public License for more details.
-## 
-## You should have received a copy of the GNU Lesser General Public License
-## along with CAMP.  If not, see <http://www.gnu.org/licenses/>.
+## The MIT License (MIT)
+##
+## Copyright (c) 2009-2014 TEGESO/TEGESOFT
+##
+## Permission is hereby granted, free of charge, to any person obtaining a copy
+## of this software and associated documentation files (the "Software"), to deal
+## in the Software without restriction, including without limitation the rights
+## to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+## copies of the Software, and to permit persons to whom the Software is
+## furnished to do so, subject to the following conditions:
+##
+## The above copyright notice and this permission notice shall be included in
+## all copies or substantial portions of the Software.
+##
+## THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+## IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+## FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+## AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+## LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+## OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+## THE SOFTWARE.
 ##
 ###############################################################################
 
 
-cmake_minimum_required(VERSION 2.6)
+cmake_minimum_required(VERSION 2.8.8)
 
 # set project's name
 project(CAMP)
+
+# require C++11 standard by default
+set(CMAKE_CXX_STANDARD 11)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 # include project configuration
 include(${CMAKE_SOURCE_DIR}/cmake/Config.cmake)
@@ -148,7 +161,7 @@
 
 # define the export macro
 if(BUILD_SHARED_LIBS)
-    set_target_properties(camp PROPERTIES DEFINE_SYMBOL CAMP_EXPORTS)
+    set_target_properties(camp PROPERTIES DEFINE_SYMBOL CAMP_EXPORTS SOVERSION "${VERSION_MAJOR}.${VERSION_MINOR}" VERSION "${VERSION_STR}")
 else()
     add_definitions(-DCAMP_STATIC)
 endif()
@@ -167,6 +180,7 @@
 
 # add the test subdirectory, but do not build it by default
 if(BUILD_TEST)
+    enable_testing()
     add_subdirectory(test)
 endif()
 
@@ -175,6 +189,26 @@
 ###############################
 
 add_subdirectory(doc)
+
+###############################
+# support files
+###############################
+# pkg-config
+configure_file(cmake/camp.pc.in ${CMAKE_BINARY_DIR}/camp.pc @ONLY)
+
+# cmake
+include(CMakePackageConfigHelpers)
+
+configure_package_config_file(cmake/CAMPConfig.cmake.in
+    ${CMAKE_CURRENT_BINARY_DIR}/CAMPConfig.cmake
+    INSTALL_DESTINATION lib/camp/cmake
+)
+
+write_basic_package_version_file(
+    ${CMAKE_CURRENT_BINARY_DIR}/CAMPConfigVersion.cmake
+    VERSION ${VERSION_STR}
+    COMPATIBILITY AnyNewerVersion
+)
 
 ###############################
 # installing
@@ -191,12 +225,29 @@
 )
 
 install(TARGETS camp
+    EXPORT CAMPTargets
     RUNTIME DESTINATION bin COMPONENT bin
-    LIBRARY DESTINATION lib COMPONENT bin 
+    LIBRARY DESTINATION lib COMPONENT bin
     ARCHIVE DESTINATION lib COMPONENT devel
 )
 
-install(FILES README.txt COPYING.txt LICENSE.LGPL3.txt
+install(FILES ${CMAKE_BINARY_DIR}/camp.pc
+    DESTINATION lib/pkgconfig
+    COMPONENT devel
+)
+
+install(EXPORT CAMPTargets
+    NAMESPACE camp::
+    DESTINATION lib/camp/cmake
+    COMPONENT devel
+)
+
+install(FILES ${CMAKE_CURRENT_BINARY_DIR}/CAMPConfig.cmake ${CMAKE_CURRENT_BINARY_DIR}/CAMPConfigVersion.cmake
+    DESTINATION lib/camp/cmake
+    COMPONENT devel
+)
+
+install(FILES README.txt COPYING.txt
     DESTINATION ${INSTALL_MISC_DIR}
 )

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -1,22 +1,31 @@
 ###############################################################################
 ##
-## Copyright (C) 2009-2010 TECHNOGERMA Systems France and/or its subsidiary(-ies).
-## Contact: Technogerma Systems France Information (contact@technogerma.fr)
+## Copyright (C) 2009-2014 TEGESO/TEGESOFT and/or its subsidiary(-ies) and mother company.
+## Contact: Tegesoft Information (contact@tegesoft.com)
 ##
 ## This file is part of the CAMP library.
 ##
-## CAMP is free software: you can redistribute it and/or modify
-## it under the terms of the GNU Lesser General Public License as published by
-## the Free Software Foundation, either version 3 of the License, or
-## (at your option) any later version.
+## The MIT License (MIT)
 ## 
-## CAMP is distributed in the hope that it will be useful,
-## but WITHOUT ANY WARRANTY; without even the implied warranty of
-## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-## GNU Lesser General Public License for more details.
+## Copyright (c) 2009-2014 TEGESO/TEGESOFT
 ## 
-## You should have received a copy of the GNU Lesser General Public License
-## along with CAMP.  If not, see <http://www.gnu.org/licenses/>.
+## Permission is hereby granted, free of charge, to any person obtaining a copy
+## of this software and associated documentation files (the "Software"), to deal
+## in the Software without restriction, including without limitation the rights
+## to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+## copies of the Software, and to permit persons to whom the Software is
+## furnished to do so, subject to the following conditions:
+## 
+## The above copyright notice and this permission notice shall be included in
+## all copies or substantial portions of the Software.
+## 
+## THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+## IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+## FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+## AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+## LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+## OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+## THE SOFTWARE.
 ##
 ###############################################################################

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -1,22 +1,31 @@
 ###############################################################################
 ##
-## Copyright (C) 2009-2010 TECHNOGERMA Systems France and/or its subsidiary(-ies).
-## Contact: Technogerma Systems France Information (contact@technogerma.fr)
+## Copyright (C) 2009-2014 TEGESO/TEGESOFT and/or its subsidiary(-ies) and mother company.
+## Contact: Tegesoft Information (contact@tegesoft.com)
 ##
 ## This file is part of the CAMP library.
 ##
-## CAMP is free software: you can redistribute it and/or modify
-## it under the terms of the GNU Lesser General Public License as published by
-## the Free Software Foundation, either version 3 of the License, or
-## (at your option) any later version.
-## 
-## CAMP is distributed in the hope that it will be useful,
-## but WITHOUT ANY WARRANTY; without even the implied warranty of
-## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-## GNU Lesser General Public License for more details.
-## 
-## You should have received a copy of the GNU Lesser General Public License
-## along with CAMP.  If not, see <http://www.gnu.org/licenses/>.
+## The MIT License (MIT)
+##
+## Copyright (c) 2009-2014 TEGESO/TEGESOFT
+##
+## Permission is hereby granted, free of charge, to any person obtaining a copy
+## of this software and associated documentation files (the "Software"), to deal
+## in the Software without restriction, including without limitation the rights
+## to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+## copies of the Software, and to permit persons to whom the Software is
+## furnished to do so, subject to the following conditions:
+##
+## The above copyright notice and this permission notice shall be included in
+## all copies or substantial portions of the Software.
+##
+## THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+## IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+## FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+## AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+## LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+## OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+## THE SOFTWARE.
 ##
 ###############################################################################
 
@@ -89,6 +98,9 @@
 # last thing we have to do is to tell CMake what libraries our executable needs,
 target_link_libraries(camptest camp)
 
+# - Add the executable as a CTest
+add_test(camptest camptest)
+
 # add the qt subdirectory, but do not build it by default
 if(BUILD_TEST_QT)
     add_subdirectory(qt)

=== debian/changelog ===
camp (0.8.4-5) unstable; urgency=medium

  * Team upload.
  * Fix Build issue with CMake 4
    Closes: #1112760
  * d/watch: version=5
  * Standards-Version: 4.7.2 (routine-update)
  * debputy lint --auto-fix (routine-update)
  * Remove package relations to 0.7 versions that do not exist any more
  * Remove version from Conflicts libcamp0.8

 -- Andreas Tille <tille@debian.org>  Fri, 17 Oct 2025 10:07:48 +0200

camp (0.8.4-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062037

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 05:39:20 +0000

camp (0.8.4-4) unstable; urgency=medium

  * Team upload.
  * Fix watch file
  * Apply multi-arch hints.
    + libcamp-dev: Add Multi-Arch: same.

 -- Andreas Tille <tille@debian.org>  Mon, 08 Nov 2021 21:30:04 +0100

camp (0.8.4-3) unstable; urgency=medium

  * d/patches: fix CMake patch to support multi-arch paths properly
  * d/*: update urls

 -- Flavien Bridault <fbridault@ircad.fr>  Tue, 19 Oct 2021 12:57:58 +0000

camp (0.8.4-2) unstable; urgency=medium

  * Team upload.

  [ Debian Janitor ]
  * Apply multi-arch hints.
    + libcamp-dev: Drop Multi-Arch: same.

  [ Steffen Moeller ]
  * Fix watchfile to detect new versions on github (routine-update)

  [ Andreas Tille ]
  * Standards-Version: 4.6.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Trim trailing whitespace.
  * Update watch file format version to 4.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Install not yet installed pkgconfig and cmake files

  [ Flavien Bridault ]
  * d/patches: Add do_not_install_misc_cmake_files.patch

 -- Andreas Tille <tille@debian.org>  Wed, 15 Sep 2021 16:43:03 +0200

camp (0.8.4-1) unstable; urgency=medium

  [ Flavien Bridault ]
  * New upstream version 0.8.4.
  * d/control: Change HomePage
  * d/copyright: Change source url
  * d/watch: Change url
  * cme fix dpkg

  [ Andreas Tille ]
  * debhelper 12

 -- Flavien Bridault <fbridault@ircad.fr>  Mon, 09 Dec 2019 07:47:39 +0000

=== debian/control ===
--- 
+++ 
@@ -1,28 +1,36 @@
 Source: camp
+Standards-Version: 4.7.2
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Flavien Bridault <fbridault@ircad.fr>
+Uploaders:
+ Flavien Bridault <fbridault@ircad.fr>,
 Section: science
 Priority: optional
-Build-Depends: cmake,
-               debhelper (>= 11~),
-               d-shlibs,
-               libboost-dev,
-               libboost-test-dev,
-               qtbase5-dev
-Standards-Version: 4.4.0
+Build-Depends:
+ dpkg-dev (>= 1.22.5),
+ cmake,
+ debhelper-compat (= 13),
+ d-shlibs (>= 0.106~),
+ libboost-dev,
+ libboost-test-dev,
+ qtbase5-dev,
 Vcs-Browser: https://salsa.debian.org/med-team/camp
 Vcs-Git: https://salsa.debian.org/med-team/camp.git
-Homepage: https://github.com/tegesoft/camp
+Homepage: https://github.com/IRCAD/camp
+Rules-Requires-Root: no
 
-Package: libcamp0.8
+Package: libcamp0.8t64
 Architecture: any
 Multi-Arch: same
 Section: libs
-Depends: ${shlibs:Depends},
-         ${misc:Depends}
-Conflicts: libcamp0.7
-Provides: libcamp0.7
-Replaces: libcamp0.7
+Depends:
+ ${shlibs:Depends},
+ ${misc:Depends},
+Conflicts:
+ libcamp0.8,
+Provides:
+ ${t64:Provides},
+Replaces:
+ libcamp0.8,
 Description: C++ multi-purpose reflection library
  CAMP is a multi-purpose reflection library developed by Technogerma Systems
  France (http://www.tegesoft.com).
@@ -50,12 +58,10 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libcamp0.8 (= ${binary:Version}),
-         ${shlibs:Depends},
-         ${misc:Depends}
-Conflicts: libcamp0.7-dev
-Provides: libcamp0.7-dev
-Replaces: libcamp0.7-dev
+Depends:
+ libcamp0.8t64 (= ${binary:Version}),
+ ${shlibs:Depends},
+ ${misc:Depends},
 Description: C++ multi-purpose reflection library (development files)
  CAMP is a multi-purpose reflection library developed by Technogerma Systems
  France (http://www.tegesoft.com).

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_TEST=TRUE -DBUILD_TEST_QT=TRUE -DCMAKE_POLICY_VERSION_MINIMUM=3.5

override_dh_install:
	dh_install
	d-shlibmove \
		--t64 \
		--commit --multiarch --devunversioned --exclude-a --exclude-la \
		--movedev debian/tmp/usr/include/camp usr/include \
		--movedev debian/tmp/usr/include/camp-xml usr/include \
		--movedev debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}/cmake/camp usr/lib/${DEB_HOST_MULTIARCH}/cmake \
		--movedev debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}/pkgconfig/camp.pc usr/lib/${DEB_HOST_MULTIARCH}/pkgconfig \
		debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}/*.so
	find debian -name camp.pc.in -delete

=== debian/watch ===
Version: 5

Template: Github
Owner: IRCAD
Project: camp
